﻿Imports System.ComponentModel

Public Class FilterWorker
    Inherits BackgroundWorker

    Private _wordList() As String
    Private _filterText As String

    Public Sub New()
        MyBase.New()
        Me.WorkerSupportsCancellation = True
    End Sub

    Public Property FilterText() As String
        Get
            Return _filterText
        End Get
        Set(ByVal value As String)
            _filterText = value
        End Set
    End Property

    Public Property WordList() As String()
        Get
            Return _wordList
        End Get
        Set(ByVal value As String())
            _wordList = value
        End Set
    End Property

    Protected Overrides Sub OnDoWork(ByVal e As System.ComponentModel.DoWorkEventArgs)
        Dim newWordList As New List(Of String)()

        For Each word As String In _wordList
            If Me.CancellationPending Then
                e.Result = Nothing
                Return
            End If

            If word.StartsWith(Me.FilterText, StringComparison.CurrentCultureIgnoreCase) Then
                newWordList.Add(word)
            End If
        Next

        e.Result = newWordList.ToArray()
    End Sub

End Class
