﻿Imports System.IO
Imports StringBuilder = System.Text.StringBuilder

Public Class Form1

    Private Const DictionaryPath As String = "wordlist.txt"

    ' Creates a comma-separated word list based off of all files under the My Documents directory.
    Private Sub CreateWordList()
        If Not File.Exists(DictionaryPath) Then
            Using writer As New StreamWriter(DictionaryPath)
                Dim folderPath As String = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
                Dim dir As New DirectoryInfo(folderPath)
                Dim fileNames() As FileInfo = dir.GetFiles("*.*", SearchOption.AllDirectories)

                For i As Integer = 0 To fileNames.Length - 1
                    writer.Write(fileNames(i).Name)

                    If i <> fileNames.Length - 1 Then
                        writer.Write(",")
                    End If
                Next
            End Using
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CreateWordList()
        Dim words() As String = GetWordList()
        FilteringBox1.AddItems(words)
    End Sub

    Private Function GetWordList() As String()
        Dim words As New List(Of String)()
        Dim accumulator As New StringBuilder()

        Using reader As StreamReader = New StreamReader(DictionaryPath)
            While Not reader.EndOfStream
                Dim readValue As Integer = reader.Read()

                If readValue <> -1 Then
                    Dim currentChar As Char = Chr(readValue)
                    If currentChar <> "," Then
                        accumulator.Append(currentChar)
                    Else
                        words.Add(accumulator.ToString())
                        accumulator.Remove(0, accumulator.Length)
                    End If
                End If
            End While
        End Using

        Return words.ToArray()
    End Function
End Class
